collectgarbage("stop")
local ffi = require('ffi')

local state1 = ffi.new("struct { uint64_t counter1, counter2; }")

local stepper1 = {
	step1 = function(self)
		state1.counter1 = state1.counter1 + 20
		self.step = self.step2
	end,

	step2 = function(self)
		if state1.counter1 > 0 then
			state1.counter1 = state1.counter1 - 1
			return
		end
		self.step = self.step1
	end
}

stepper1.step = stepper1.step2

local function updateStepper1()
	stepper1:step()
	state1.counter2 = state1.counter2 + 20
end

local ops = {}
for i = 0, 340 do
	ops[i] = function() end
end

ops[0] = function() end
ops[1] = function() end
ops[2] = function() end
ops[3] = function() end
ops[4] = function() end
ops[5] = function() end
ops[6] = function() end
ops[7] = function() end
ops[8] = function() end
ops[9] = function() end
ops[10] = function() end
ops[65] = function() end
ops[66] = function() end
ops[67] = function() end
ops[68] = function() end
ops[69] = function() end
ops[70] = function() end
ops[71] = function() end
ops[72] = function() end
ops[249] = function() end
ops[250] = function() end
ops[251] = function() end
ops[252] = function() end
ops[253] = function() end
ops[254] = function() end
ops[256] = function() end
ops[257] = function() end
ops[259] = function() end
ops[260] = function() end

local state2 = ffi.new("struct { int fn; }")

local function updateStepper2()
	for i = 1, 10 do
		ops[state2.fn]()
		state2.fn = state2.fn + 1
		if state2.fn == 341 then
			state2.fn = 0
		end
	end
end

local mode = 1

function love.draw()
	if mode == 1 then
		for i = 1, 1000000 do
			updateStepper2()
			updateStepper1()
		end
	else
		for i = 1, 1000000 do
			updateStepper1()
			updateStepper2()
		end
	end
	return love.graphics.print(("%d: %d"):format(mode, collectgarbage("count")), 10, 10)
end

function love.keypressed(key)
	if key == 'space' then
		mode = mode == 1 and 2 or 1
	end
end
